Index: /quintagroup.portlet.static/tags/0.2/MANIFEST.in
===================================================================
--- /quintagroup.portlet.static/tags/0.2/MANIFEST.in	(revision 2481)
+++ /quintagroup.portlet.static/tags/0.2/MANIFEST.in	(revision 2481)
@@ -0,0 +1,3 @@
+recursive-include docs *
+recursive-include quintagroup *
+global-exclude *pyc
Index: /quintagroup.portlet.static/tags/0.2/README.txt
===================================================================
--- /quintagroup.portlet.static/tags/0.2/README.txt	(revision 2481)
+++ /quintagroup.portlet.static/tags/0.2/README.txt	(revision 2481)
@@ -0,0 +1,42 @@
+quintagroup.portlet.static
+==========================
+
+quintagroup.portlet.static is a Plone product that allows you to add stylished
+static text portlets to your Plone site. Static Stylish Text portlets are 
+usual Plone Static Text portlets with certain HTML classes assigned. 
+
+Static Stylish Text portlets can be used in those cases when you need to have
+several static text portlets be displayed in different ways. For this, 
+go to Site Setup -> Add-on Products Configuration -> Static Stylish portlet
+(www.yoursite/@@staticstylishportlet-controlpanel). In Static Stylish portlet
+settings area create HTML classes and specify CSS styles for those HTML 
+classes in the corresponding CSS file. These classes will be available for 
+you in a Portlet style drop down menu on static stylish text portlet add/edit form. 
+
+Usage
+-----
+
+* Select Static Stylish text portlet from Add portlet drop-down menu
+
+* Provide content to be displayed on the portlet [as you would do for
+  usual Plone static text portlets
+
+* Choose a portlet style for the portlet from the list of available HTML
+  classes.
+
+* Save changes.
+
+Supported Plone version
+-----------------------
+
+* 3.x
+
+Authors
+-------
+
+* Vitaliy Podoba
+
+* Roman Kozlovskyi
+
+Copyright (c) "Quintagroup": http://quintagroup.com/, 2010
+
Index: /quintagroup.portlet.static/tags/0.2/docs/HISTORY.txt
===================================================================
--- /quintagroup.portlet.static/tags/0.2/docs/HISTORY.txt	(revision 2481)
+++ /quintagroup.portlet.static/tags/0.2/docs/HISTORY.txt	(revision 2481)
@@ -0,0 +1,13 @@
+Changelog
+=========
+
+0.2 - June 04, 2010
+-------------------
+
+* Fixed MANIFEST.in [kroman0]
+
+
+0.1 - February 25, 2009
+-----------------------
+
+* Initial release
Index: /quintagroup.portlet.static/tags/0.2/docs/INSTALL.txt
===================================================================
--- /quintagroup.portlet.static/tags/0.2/docs/INSTALL.txt	(revision 2481)
+++ /quintagroup.portlet.static/tags/0.2/docs/INSTALL.txt	(revision 2481)
@@ -0,0 +1,39 @@
+quintagroup.portlet.static Installation
+=======================
+
+ * When you're reading this you have probably already run
+   ``easy_install quintagroup.portlet.static``. Find out how to install setuptools
+   (and EasyInstall) here:
+   http://peak.telecommunity.com/DevCenter/EasyInstall
+
+ * Create a file called ``quintagroup.portlet.static-configure.zcml`` in the
+   ``/path/to/instance/etc/package-includes`` directory.  The file
+   should only contain this::
+
+       <include package="quintagroup.portlet.static" />
+
+Alternatively, if you are using zc.buildout and the plone.recipe.zope2instance
+recipe to manage your project, you can do this:
+
+ * Add ``quintagroup.portlet.static`` to the list of eggs to install, e.g.:
+
+    [buildout]
+    ...
+    eggs =
+        ...
+        quintagroup.portlet.static
+
+  * Tell the plone.recipe.zope2instance recipe to install a ZCML slug:
+
+    [instance]
+    recipe = plone.recipe.zope2instance
+    ...
+    zcml =
+        quintagroup.portlet.static
+
+  * Re-run buildout, e.g. with:
+
+    $ ./bin/buildout
+
+You can skip the ZCML slug if you are going to explicitly include the package
+from another package's configure.zcml file.
Index: /quintagroup.portlet.static/tags/0.2/docs/LICENSE.GPL
===================================================================
--- /quintagroup.portlet.static/tags/0.2/docs/LICENSE.GPL	(revision 2481)
+++ /quintagroup.portlet.static/tags/0.2/docs/LICENSE.GPL	(revision 2481)
@@ -0,0 +1,225 @@
+		    GNU GENERAL PUBLIC LICENSE
+   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
+
+  0. This License applies to any program or other work which contains
+a notice placed by the copyright holder saying it may be distributed
+under the terms of this General Public License.  The "Program", below,
+refers to any such program or work, and a "work based on the Program"
+means either the Program or any derivative work under copyright law:
+that is to say, a work containing the Program or a portion of it,
+either verbatim or with modifications and/or translated into another
+language.  (Hereinafter, translation is included without limitation in
+the term "modification".)  Each licensee is addressed as "you".
+
+Activities other than copying, distribution and modification are not
+covered by this License; they are outside its scope.  The act of
+running the Program is not restricted, and the output from the Program
+is covered only if its contents constitute a work based on the
+Program (independent of having been made by running the Program).
+Whether that is true depends on what the Program does.
+
+  1. You may copy and distribute verbatim copies of the Program's
+source code as you receive it, in any medium, provided that you
+conspicuously and appropriately publish on each copy an appropriate
+copyright notice and disclaimer of warranty; keep intact all the
+notices that refer to this License and to the absence of any warranty;
+and give any other recipients of the Program a copy of this License
+along with the Program.
+
+You may charge a fee for the physical act of transferring a copy, and
+you may at your option offer warranty protection in exchange for a fee.
+
+  2. You may modify your copy or copies of the Program or any portion
+of it, thus forming a work based on the Program, and copy and
+distribute such modifications or work under the terms of Section 1
+above, provided that you also meet all of these conditions:
+
+    a) You must cause the modified files to carry prominent notices
+    stating that you changed the files and the date of any change.
+
+    b) You must cause any work that you distribute or publish, that in
+    whole or in part contains or is derived from the Program or any
+    part thereof, to be licensed as a whole at no charge to all third
+    parties under the terms of this License.
+
+    c) If the modified program normally reads commands interactively
+    when run, you must cause it, when started running for such
+    interactive use in the most ordinary way, to print or display an
+    announcement including an appropriate copyright notice and a
+    notice that there is no warranty (or else, saying that you provide
+    a warranty) and that users may redistribute the program under
+    these conditions, and telling the user how to view a copy of this
+    License.  (Exception: if the Program itself is interactive but
+    does not normally print such an announcement, your work based on
+    the Program is not required to print an announcement.)
+
+
+These requirements apply to the modified work as a whole.  If
+identifiable sections of that work are not derived from the Program,
+and can be reasonably considered independent and separate works in
+themselves, then this License, and its terms, do not apply to those
+sections when you distribute them as separate works.  But when you
+distribute the same sections as part of a whole which is a work based
+on the Program, the distribution of the whole must be on the terms of
+this License, whose permissions for other licensees extend to the
+entire whole, and thus to each and every part regardless of who wrote it.
+
+Thus, it is not the intent of this section to claim rights or contest
+your rights to work written entirely by you; rather, the intent is to
+exercise the right to control the distribution of derivative or
+collective works based on the Program.
+
+In addition, mere aggregation of another work not based on the Program
+with the Program (or with a work based on the Program) on a volume of
+a storage or distribution medium does not bring the other work under
+the scope of this License.
+
+  3. You may copy and distribute the Program (or a work based on it,
+under Section 2) in object code or executable form under the terms of
+Sections 1 and 2 above provided that you also do one of the following:
+
+    a) Accompany it with the complete corresponding machine-readable
+    source code, which must be distributed under the terms of Sections
+    1 and 2 above on a medium customarily used for software interchange; or,
+
+    b) Accompany it with a written offer, valid for at least three
+    years, to give any third party, for a charge no more than your
+    cost of physically performing source distribution, a complete
+    machine-readable copy of the corresponding source code, to be
+    distributed under the terms of Sections 1 and 2 above on a medium
+    customarily used for software interchange; or,
+
+    c) Accompany it with the information you received as to the offer
+    to distribute corresponding source code.  (This alternative is
+    allowed only for noncommercial distribution and only if you
+    received the program in object code or executable form with such
+    an offer, in accord with Subsection b above.)
+
+The source code for a work means the preferred form of the work for
+making modifications to it.  For an executable work, complete source
+code means all the source code for all modules it contains, plus any
+associated interface definition files, plus the scripts used to
+control compilation and installation of the executable.  However, as a
+special exception, the source code distributed need not include
+anything that is normally distributed (in either source or binary
+form) with the major components (compiler, kernel, and so on) of the
+operating system on which the executable runs, unless that component
+itself accompanies the executable.
+
+If distribution of executable or object code is made by offering
+access to copy from a designated place, then offering equivalent
+access to copy the source code from the same place counts as
+distribution of the source code, even though third parties are not
+compelled to copy the source along with the object code.
+
+
+  4. You may not copy, modify, sublicense, or distribute the Program
+except as expressly provided under this License.  Any attempt
+otherwise to copy, modify, sublicense or distribute the Program is
+void, and will automatically terminate your rights under this License.
+However, parties who have received copies, or rights, from you under
+this License will not have their licenses terminated so long as such
+parties remain in full compliance.
+
+  5. You are not required to accept this License, since you have not
+signed it.  However, nothing else grants you permission to modify or
+distribute the Program or its derivative works.  These actions are
+prohibited by law if you do not accept this License.  Therefore, by
+modifying or distributing the Program (or any work based on the
+Program), you indicate your acceptance of this License to do so, and
+all its terms and conditions for copying, distributing or modifying
+the Program or works based on it.
+
+  6. Each time you redistribute the Program (or any work based on the
+Program), the recipient automatically receives a license from the
+original licensor to copy, distribute or modify the Program subject to
+these terms and conditions.  You may not impose any further
+restrictions on the recipients' exercise of the rights granted herein.
+You are not responsible for enforcing compliance by third parties to
+this License.
+
+  7. If, as a consequence of a court judgment or allegation of patent
+infringement or for any other reason (not limited to patent issues),
+conditions are imposed on you (whether by court order, agreement or
+otherwise) that contradict the conditions of this License, they do not
+excuse you from the conditions of this License.  If you cannot
+distribute so as to satisfy simultaneously your obligations under this
+License and any other pertinent obligations, then as a consequence you
+may not distribute the Program at all.  For example, if a patent
+license would not permit royalty-free redistribution of the Program by
+all those who receive copies directly or indirectly through you, then
+the only way you could satisfy both it and this License would be to
+refrain entirely from distribution of the Program.
+
+If any portion of this section is held invalid or unenforceable under
+any particular circumstance, the balance of the section is intended to
+apply and the section as a whole is intended to apply in other
+circumstances.
+
+It is not the purpose of this section to induce you to infringe any
+patents or other property right claims or to contest validity of any
+such claims; this section has the sole purpose of protecting the
+integrity of the free software distribution system, which is
+implemented by public license practices.  Many people have made
+generous contributions to the wide range of software distributed
+through that system in reliance on consistent application of that
+system; it is up to the author/donor to decide if he or she is willing
+to distribute software through any other system and a licensee cannot
+impose that choice.
+
+This section is intended to make thoroughly clear what is believed to
+be a consequence of the rest of this License.
+
+
+  8. If the distribution and/or use of the Program is restricted in
+certain countries either by patents or by copyrighted interfaces, the
+original copyright holder who places the Program under this License
+may add an explicit geographical distribution limitation excluding
+those countries, so that distribution is permitted only in or among
+countries not thus excluded.  In such case, this License incorporates
+the limitation as if written in the body of this License.
+
+  9. The Free Software Foundation may publish revised and/or new versions
+of the General Public License from time to time.  Such new versions will
+be similar in spirit to the present version, but may differ in detail to
+address new problems or concerns.
+
+Each version is given a distinguishing version number.  If the Program
+specifies a version number of this License which applies to it and "any
+later version", you have the option of following the terms and conditions
+either of that version or of any later version published by the Free
+Software Foundation.  If the Program does not specify a version number of
+this License, you may choose any version ever published by the Free Software
+Foundation.
+
+  10. If you wish to incorporate parts of the Program into other free
+programs whose distribution conditions are different, write to the author
+to ask for permission.  For software which is copyrighted by the Free
+Software Foundation, write to the Free Software Foundation; we sometimes
+make exceptions for this.  Our decision will be guided by the two goals
+of preserving the free status of all derivatives of our free software and
+of promoting the sharing and reuse of software generally.
+
+			    NO WARRANTY
+
+  11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
+FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT WHEN
+OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES
+PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED
+OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS
+TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE
+PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,
+REPAIR OR CORRECTION.
+
+  12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
+WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR
+REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,
+INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING
+OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED
+TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY
+YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER
+PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE
+POSSIBILITY OF SUCH DAMAGES.
+
+		     END OF TERMS AND CONDITIONS
Index: /quintagroup.portlet.static/tags/0.2/docs/LICENSE.txt
===================================================================
--- /quintagroup.portlet.static/tags/0.2/docs/LICENSE.txt	(revision 2481)
+++ /quintagroup.portlet.static/tags/0.2/docs/LICENSE.txt	(revision 2481)
@@ -0,0 +1,16 @@
+  quintagroup.portlet.static is copyright Vitaliy Podoba
+
+  This program is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 2 of the License, or
+  (at your option) any later version.
+
+  This program is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License
+  along with this program; if not, write to the Free Software
+  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
+  MA 02111-1307 USA.
Index: /quintagroup.portlet.static/tags/0.2/quintagroup/__init__.py
===================================================================
--- /quintagroup.portlet.static/tags/0.2/quintagroup/__init__.py	(revision 2481)
+++ /quintagroup.portlet.static/tags/0.2/quintagroup/__init__.py	(revision 2481)
@@ -0,0 +1,6 @@
+# See http://peak.telecommunity.com/DevCenter/setuptools#namespace-packages
+try:
+    __import__('pkg_resources').declare_namespace(__name__)
+except ImportError:
+    from pkgutil import extend_path
+    __path__ = extend_path(__path__, __name__)
Index: /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/__init__.py
===================================================================
--- /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/__init__.py	(revision 2481)
+++ /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/__init__.py	(revision 2481)
@@ -0,0 +1,6 @@
+# See http://peak.telecommunity.com/DevCenter/setuptools#namespace-packages
+try:
+    __import__('pkg_resources').declare_namespace(__name__)
+except ImportError:
+    from pkgutil import extend_path
+    __path__ = extend_path(__path__, __name__)
Index: /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/__init__.py
===================================================================
--- /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/__init__.py	(revision 2481)
+++ /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/__init__.py	(revision 2481)
@@ -0,0 +1,5 @@
+from zope.i18nmessageid import MessageFactory
+StaticStylishPortletMessageFactory = MessageFactory('quintagroup.portlet.static')
+
+def initialize(context):
+    """Initializer called when used as a Zope 2 product."""
Index: /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/browser/__init__.py
===================================================================
--- /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/browser/__init__.py	(revision 2481)
+++ /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/browser/__init__.py	(revision 2481)
@@ -0,0 +1,1 @@
+#
Index: /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/browser/configlet.py
===================================================================
--- /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/browser/configlet.py	(revision 2481)
+++ /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/browser/configlet.py	(revision 2481)
@@ -0,0 +1,90 @@
+from zope.interface import Interface
+from zope.component import adapts
+from zope.interface import implements
+from zope import schema
+from zope.app.form import CustomWidgetFactory
+from zope.app.form.browser import ObjectWidget
+from zope.app.form.browser import ListSequenceWidget
+from zope.formlib import form
+
+from Products.CMFCore.utils import getToolByName
+from Products.CMFDefault.formlib.schema import SchemaAdapterBase
+
+from Products.CMFPlone.interfaces import IPloneSiteRoot
+
+from plone.app.controlpanel.form import ControlPanelForm
+
+from quintagroup.portlet.static import StaticStylishPortletMessageFactory as _
+from quintagroup.portlet.static.utils import getVocabulary
+
+
+class IValueTitlePair(Interface):
+    value = schema.TextLine(title=u"value", required=True)
+    title = schema.TextLine(title=u"title", required=False)
+
+class ValueTitlePair(object):
+    implements(IValueTitlePair)
+    def __init__(self, value='', title=''):
+        self.value = value
+        self.title = title
+
+class IStaticStylishPortletPanelSchema(Interface):
+
+    portlet_dropdown = schema.List(
+        title=_(u'Dropdown select'),
+        description=_(u"These entries are used for generating dropdown select "
+                      "for static stylish portlet. Note: pipe (|) "
+                      "symbol is not allowed in the value field."),
+        value_type=schema.Object(IValueTitlePair, title=u"entry"),
+        required=True
+    )
+
+class StaticStylishPortletControlPanelAdapter(SchemaAdapterBase):
+    adapts(IPloneSiteRoot)
+    implements(IStaticStylishPortletPanelSchema)
+
+    def __init__(self, context):
+        super(StaticStylishPortletControlPanelAdapter, self).__init__(context)
+        self.context = context
+        self.pp = getToolByName(context, 'portal_properties', None)
+
+    def get_portlet_dropdown(self):
+        return  [ValueTitlePair(v,t) for (v,t) in getVocabulary(self.context)]
+
+    def set_portlet_dropdown(self, value):
+        dropdown_list = []
+        for vt in value:
+            value = vt.value
+            title = vt.title or value
+            dropdown_list.append('%s|%s' % (value, title))
+        self.setValue(dropdown_list)
+
+    portlet_dropdown = property(get_portlet_dropdown, set_portlet_dropdown)
+
+    def setValue(self, value):
+        if self.pp is not None:
+            if getattr(self.pp, 'staticportlet_properties', None) is None:
+                self.pp.addPropertySheet(
+                    'staticportlet_properties',
+                    'Static Stylish portlet properties'
+                )
+            sheet = getattr(self.pp, 'staticportlet_properties', None)
+            if not sheet.hasProperty('portlet_dropdown'):
+                sheet.manage_addProperty('portlet_dropdown', value, 'lines')
+            else:
+                sheet.manage_changeProperties(portlet_dropdown=value)
+
+valuetitle_widget = CustomWidgetFactory(ObjectWidget, ValueTitlePair)
+combination_widget = CustomWidgetFactory(ListSequenceWidget,
+                                         subwidget=valuetitle_widget)
+
+class StaticStylishPortletControlPanel(ControlPanelForm):
+
+    form_fields = form.FormFields(IStaticStylishPortletPanelSchema)
+    form_fields['portlet_dropdown'].custom_widget = combination_widget
+
+    label = _("Static Stylish portlet settings")
+    description = _("This form is for managing Static Stylish portlet "
+                     "classes available on portlet add/edit form.")
+    form_name = _("Static Stylish portlet settings")
+
Index: /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/browser/configure.zcml
===================================================================
--- /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/browser/configure.zcml	(revision 2481)
+++ /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/browser/configure.zcml	(revision 2481)
@@ -0,0 +1,17 @@
+<configure
+    xmlns="http://namespaces.zope.org/zope"
+    xmlns:i18n="http://namespaces.zope.org/i18n"
+    xmlns:browser="http://namespaces.zope.org/browser"
+    i18n_domain="quintagroup.portlet.static">
+
+  <adapter factory=".configlet.StaticStylishPortletControlPanelAdapter" />
+
+  <browser:page
+      name="staticstylishportlet-controlpanel"
+      for="Products.CMFPlone.interfaces.IPloneSiteRoot"
+      class=".configlet.StaticStylishPortletControlPanel"
+      permission="cmf.ManagePortal"
+      />
+
+</configure>
+
Index: /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/configlet.txt
===================================================================
--- /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/configlet.txt	(revision 2481)
+++ /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/configlet.txt	(revision 2481)
@@ -0,0 +1,144 @@
+Static Stylish portlet configlet
+================================
+
+Static Stylish portlet ships with it's own configuration page which you can
+access at:
+    ${your/portal/url}/@@staticstylishportlet-controlpanel
+
+or from Plone Control Panel under 'Add-on Product Configuration' section.
+
+
+Prepare testing environment
+---------------------------
+
+We use zope.testbrowser to simulate browser interaction in order to show
+the main flow of pages. This is not a true functional test, because we also
+inspect and modify the internal state of the ZODB, but it is a useful way of
+making sure we test the full end-to-end process of creating and modifying
+content.
+
+    >>> from Products.Five.testbrowser import Browser
+    >>> browser = Browser()
+    >>> portal_url = self.portal.absolute_url()
+
+The following is useful when writing and debugging testbrowser tests. It lets
+us see error messages properly.
+
+    >>> browser.handleErrors = False
+    >>> self.portal.error_log._ignored_exceptions = ()
+
+We then turn off the various portlets, because they sometimes duplicate links
+and text (e.g. the navtree, the recent recent items listing) that we wish to
+test for in our own views. Having no portlets makes things easier.
+
+    >>> from zope.component import getUtility, getMultiAdapter
+    >>> from plone.portlets.interfaces import IPortletManager
+    >>> from plone.portlets.interfaces import IPortletAssignmentMapping
+
+    >>> left_column = getUtility(IPortletManager, name=u"plone.leftcolumn")
+    >>> left_assignable = getMultiAdapter((self.portal, left_column), IPortletAssignmentMapping)
+    >>> for name in left_assignable.keys():
+    ...     del left_assignable[name]
+
+    >>> right_column = getUtility(IPortletManager, name=u"plone.rightcolumn")
+    >>> right_assignable = getMultiAdapter((self.portal, right_column), IPortletAssignmentMapping)
+    >>> for name in right_assignable.keys():
+    ...     del right_assignable[name]
+
+
+Finally, we need to log in as the portal owner, i.e. an administrator user. We
+do this from the login page.
+
+    >>> from Products.PloneTestCase.setup import portal_owner, default_password
+    >>> browser.open(portal_url + '/login_form?came_from=' + portal_url)
+    >>> browser.getControl(name='__ac_name').value = portal_owner
+    >>> browser.getControl(name='__ac_password').value = default_password
+    >>> browser.getControl(name='submit').click()
+
+
+Configlet Registration
+----------------------
+
+Firstly check whether configlet is really registered:
+
+    >>> from Products.CMFCore.utils import getToolByName
+    >>> cp = getToolByName(self.portal, 'portal_controlpanel')
+    >>> actions = [a.id for a in cp.listActions()]
+    >>> 'StaticStylishPortlet' in actions
+    True
+
+
+Access to configlet
+-------------------
+
+Let's see if we can go to /@@staticstylishportlet-controlpanel url.
+
+    >>> browser.open('%s/@@staticstylishportlet-controlpanel' % portal_url)
+
+Is there configlet title on the requested page?
+
+    >>> 'Static Stylish portlet settings' in browser.contents
+    True
+
+
+Configlet Validation Functionality
+----------------------------------
+
+Check whether validation is working properly. Set no value to new entry item.
+
+    >>> browser.getControl(name='form.portlet_dropdown.add').click()
+    >>> browser.getControl(name='form.portlet_dropdown.1.value').value = ''
+
+Now save form. We shoud obtain missing value error:
+
+    >>> browser.getControl(name='form.actions.save').click() 
+    >>> 'value: Required input is missing.' in browser.contents
+    True
+
+
+Configlet Save Functionality
+----------------------------
+
+It's time to correct previous error-prone situation. Set missing value.
+
+    >>> browser.getControl(name='form.portlet_dropdown.1.value').value = 'new_value'
+
+And submit form again. This time we should see 'Changes saved.' message:
+
+    >>> browser.getControl(name='form.actions.save').click() 
+    >>> 'Changes saved.' in browser.contents
+    True
+
+and value should be duplicated into title field since we left title input empty:
+
+    >>> browser.getControl(name='form.portlet_dropdown.1.title').value
+    'new_value'
+
+And finally check portal_properties to ensure our settings page did everything
+correctly on the back end:
+
+    >>> sheet = getToolByName(self.portal, 'portal_properties').staticportlet_properties
+    >>> 'new_value|new_value' in sheet.getProperty('portlet_dropdown')
+    True
+
+
+Configlet Cancel Functionality
+------------------------------
+
+The last thing we are going to check is configlet's Cancel button:
+
+    >>> browser.getControl(name='form.actions.cancel').click()
+    >>> 'Changes canceled.' in browser.contents
+    True
+
+    >>> browser.url.endswith('/plone_control_panel')
+    True
+
+As you can see Cancel button redirected us to Plone Control Panel.
+
+
+That's it.
+
+
+
+
Index: /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/configure.zcml
===================================================================
--- /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/configure.zcml	(revision 2481)
+++ /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/configure.zcml	(revision 2481)
@@ -0,0 +1,49 @@
+<configure
+    xmlns="http://namespaces.zope.org/zope"
+    xmlns:five="http://namespaces.zope.org/five"
+    xmlns:genericsetup="http://namespaces.zope.org/genericsetup"
+    xmlns:plone="http://namespaces.plone.org/plone"
+    xmlns:i18n="http://namespaces.zope.org/i18n"
+    i18n_domain="quintagroup.portlet.static">
+
+    <five:registerPackage package="." initialize=".initialize" />
+
+    <i18n:registerTranslations directory="locales" />
+
+    <include package=".browser" />
+
+    <genericsetup:registerProfile
+       name="default"
+       title="Static Stylish portlet"
+       directory="profiles/default"
+       description="Static portlet with one extra styling field"
+       provides="Products.GenericSetup.interfaces.EXTENSION"
+       />
+
+     <!-- Register the portlet -->
+
+     <!-- If the portlet has no configurable parameters, you can remove
+          the EditForm declaration in staticstylishportlet.py and delete
+          the 'editview' attribute from this statement.
+       -->
+
+     <include package="plone.app.portlets" />
+
+     <plone:portlet
+         name="quintagroup.portlet.static.StaticStylishPortlet"
+         interface=".staticstylishportlet.IStaticStylishPortlet"
+         assignment=".staticstylishportlet.Assignment"
+         view_permission="zope2.View"
+         edit_permission="cmf.ManagePortal"
+         renderer=".staticstylishportlet.Renderer"
+         addview=".staticstylishportlet.AddForm"
+         editview=".staticstylishportlet.EditForm"
+         />
+
+    <!-- Register the vocabularies -->
+    <utility
+        component=".vocabularies.PortletCSSVocabulary"
+        name="quintagroup.portlet.static.vocabularies.PortletCSSVocabulary"
+        />
+
+</configure>
Index: /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/locales/quintagroup.portlet.static.pot
===================================================================
--- /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/locales/quintagroup.portlet.static.pot	(revision 2481)
+++ /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/locales/quintagroup.portlet.static.pot	(revision 2481)
@@ -0,0 +1,75 @@
+msgid ""
+msgstr ""
+"Project-Id-Version: quintagroup.portlet.static 0.1\n"
+"POT-Creation-Date: 2008-10-14 11:31+0000\n"
+"PO-Revision-Date: YEAR-MO-DA HO:MI +ZONE\n"
+"Last-Translator: Vitaliy Podoba piv@quintagroup.com\n"
+"Language-Team: LANGUAGE <LL@li.org>\n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=utf-8\n"
+"Content-Transfer-Encoding: 8bit\n"
+"Plural-Forms: nplurals=1; plural=0\n"
+"Language-Code: en\n"
+"Language-Name: English\n"
+"Preferred-Encodings: utf-8 latin1\n"
+"Domain: quintagroup.portlet.static\n"
+
+#: ./vocabularies.py:12
+msgid "Blue"
+msgstr ""
+
+#: ./vocabularies.py:15
+msgid "Bright"
+msgstr ""
+
+#: ./vocabularies.py:16
+msgid "Bright with Background"
+msgstr ""
+
+#: ./staticstylishportlet.py:24
+msgid "Choose a css style for the porlet."
+msgstr ""
+
+#: ./vocabularies.py:9
+msgid "Light Green"
+msgstr ""
+
+#: ./vocabularies.py:10
+msgid "Orange"
+msgstr ""
+
+#: ./vocabularies.py:13
+msgid "Pale"
+msgstr ""
+
+#: ./vocabularies.py:14
+msgid "Pale with Background"
+msgstr ""
+
+#: ./staticstylishportlet.py:23
+msgid "Portlet style"
+msgstr ""
+
+#: ./vocabularies.py:11
+msgid "Purple"
+msgstr ""
+
+#: ./vocabularies.py:8
+msgid "Red"
+msgstr ""
+
+#. Default: "A portlet which can display static HTML text with different styles."
+#: ./staticstylishportlet.py:86
+msgid "description_staticstylish_portlet"
+msgstr ""
+
+#. Default: "Add Static Stylish text portlet"
+#: ./staticstylishportlet.py:85
+msgid "title_add_staticstylish_portlet"
+msgstr ""
+
+#. Default: "Edit Static Stylish text portlet"
+#: ./staticstylishportlet.py:101
+msgid "title_edit_staticstylish_portlet"
+msgstr ""
+
Index: /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/profiles/default/controlpanel.xml
===================================================================
--- /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/profiles/default/controlpanel.xml	(revision 2481)
+++ /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/profiles/default/controlpanel.xml	(revision 2481)
@@ -0,0 +1,12 @@
+<?xml version="1.0"?>
+<object name="portal_controlpanel"
+        meta_type="Plone Control Panel Tool"
+        xmlns:i18n="http://xml.zope.org/namespaces/i18n"
+        i18n:domain="quintagroup.portlet.static">
+ <configlet title="Static Stylish Portlet" action_id="StaticStylishPortlet"
+    appId="quintagroup.portlet.static" category="Products" condition_expr=""
+    url_expr="string:${portal_url}/@@staticstylishportlet-controlpanel"
+    visible="True" i18n:attributes="title">
+  <permission>Manage portal</permission>
+ </configlet>
+</object>
Index: /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/profiles/default/metadata.xml
===================================================================
--- /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/profiles/default/metadata.xml	(revision 2481)
+++ /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/profiles/default/metadata.xml	(revision 2481)
@@ -0,0 +1,4 @@
+<?xml version="1.0"?>
+<metadata>
+  <version>0.2</version>
+</metadata>
Index: /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/profiles/default/portlets.xml
===================================================================
--- /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/profiles/default/portlets.xml	(revision 2481)
+++ /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/profiles/default/portlets.xml	(revision 2481)
@@ -0,0 +1,16 @@
+<?xml version="1.0"?>
+<portlets
+    xmlns:i18n="http://xml.zope.org/namespaces/i18n"
+    i18n:domain="quintagroup.portlet.static">
+
+ <!-- Portlet type registrations -->
+
+ <portlet
+   addview="quintagroup.portlet.static.StaticStylishPortlet"
+   title="Static Stylish portlet"
+   description="Static portlet with one extra styling field"
+   i18n:attributes="title Static Stylish portlet;
+                    description description_evastatic_portlet;"
+   />
+
+</portlets>
Index: /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/profiles/default/propertiestool.xml
===================================================================
--- /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/profiles/default/propertiestool.xml	(revision 2481)
+++ /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/profiles/default/propertiestool.xml	(revision 2481)
@@ -0,0 +1,9 @@
+<?xml version="1.0"?>
+<object name="portal_properties" meta_type="Plone Properties Tool">
+ <object name="staticportlet_properties" meta_type="Plone Property Sheet">
+  <property name="title">Static Stylish portlet properties</property>
+  <property name="portlet_dropdown" type="lines" purge="False">
+   <element value="portletStaticClassOne|Class One"/>
+  </property>
+ </object>
+</object>
Index: /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/staticstylishportlet.pt
===================================================================
--- /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/staticstylishportlet.pt	(revision 2481)
+++ /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/staticstylishportlet.pt	(revision 2481)
@@ -0,0 +1,41 @@
+<tal:rootClass define="rootExtraClass view/data/styling;
+                       rootExtraClass python:rootExtraClass and ' %s' % rootExtraClass or ''">
+<div tal:condition="view/data/omit_border"
+     tal:attributes="class string:portletStaticText ${view/css_class}${rootExtraClass}"
+     tal:content="structure view/data/text" />
+<dl tal:condition="not:view/data/omit_border"
+    tal:attributes="class string:portlet portletStaticText ${view/css_class}${rootExtraClass}"
+    i18n:domain="plone">
+
+    <dt class="portletHeader">
+        <span class="portletTopLeft"></span>
+        <span class="portletHeaderContent">
+           <a tal:omit-tag="not:view/has_link"
+              tal:attributes="href view/data/more_url"
+              tal:content="view/data/header"
+              />
+        </span>
+        <span class="portletTopRight"></span>
+    </dt>
+
+    <dd class="portletItem odd">
+        <div tal:replace="structure view/data/text" />
+        <tal:corners condition="not:view/has_footer">
+            <span class="portletBottomLeft"></span>
+            <span class="portletBottomRight"></span>
+        </tal:corners>
+    </dd>
+    
+    <dd class="portletFooter" tal:condition="view/has_footer">
+        <span class="portletBottomLeft"></span>
+        <span>
+           <a tal:omit-tag="not:view/has_link"
+              tal:attributes="href view/data/more_url"
+              tal:content="view/data/footer"
+              />
+        </span>
+        <span class="portletBottomRight"></span>
+    </dd>
+
+</dl>
+</tal:rootClass>
Index: /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/staticstylishportlet.py
===================================================================
--- /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/staticstylishportlet.py	(revision 2481)
+++ /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/staticstylishportlet.py	(revision 2481)
@@ -0,0 +1,88 @@
+from zope.interface import implements
+
+from plone.portlets.interfaces import IPortletDataProvider
+from plone.app.portlets.portlets import base
+from plone.portlet.static import static
+from plone.app.form.widgets.wysiwygwidget import WYSIWYGWidget
+
+from zope import schema
+from zope.formlib import form
+from Products.Five.browser.pagetemplatefile import ViewPageTemplateFile
+
+from quintagroup.portlet.static.utils import getVocabulary
+from quintagroup.portlet.static import StaticStylishPortletMessageFactory as _
+
+
+class IStaticStylishPortlet(static.IStaticPortlet):
+    """A portlet
+
+    It inherits from IPortletDataProvider because for this portlet, the
+    data that is being rendered and the portlet assignment itself are the
+    same.
+    """
+
+    styling = schema.Choice(title=_(u"Portlet style"),
+                            description=_(u"Choose a css style for the porlet. "
+                                          "You can manage these entries from the plone control panel."),
+                            required=False,
+                            default='',
+                            vocabulary='quintagroup.portlet.static.vocabularies.PortletCSSVocabulary',)
+
+
+class Assignment(static.Assignment):
+    """Portlet assignment.
+
+    This is what is actually managed through the portlets UI and associated
+    with columns.
+    """
+
+    implements(IStaticStylishPortlet)
+
+    styling = ''
+    
+    def __init__(self, header=u"", text=u"", omit_border=False, footer=u"",
+                 more_url='', hide=False, styling=''):
+        super(Assignment, self).__init__(header=header, text=text, omit_border=omit_border, footer=footer,
+                                         more_url=more_url, hide=hide)
+        
+        self.styling = styling
+    
+class Renderer(static.Renderer):
+    """Portlet renderer.
+
+    This is registered in configure.zcml. The referenced page template is
+    rendered, and the implicit variable 'view' will refer to an instance
+    of this class. Other methods can be added and referenced in the template.
+    """
+
+    render = ViewPageTemplateFile('staticstylishportlet.pt')
+
+
+class AddForm(static.AddForm):
+    """Portlet add form.
+
+    This is registered in configure.zcml. The form_fields variable tells
+    zope.formlib which fields to display. The create() method actually
+    constructs the assignment that is being added.
+    """
+    form_fields = form.Fields(IStaticStylishPortlet)
+    form_fields['text'].custom_widget = WYSIWYGWidget
+
+    label = _(u"title_add_staticstylish_portlet", default=u"Add Static Stylish text portlet")
+    description = _(u"description_staticstylish_portlet", default=u"A portlet which can display static HTML text with different styles.")
+
+    def create(self, data):
+        return Assignment(**data)
+
+
+class EditForm(static.EditForm):
+    """Portlet edit form.
+
+    This is registered with configure.zcml. The form_fields variable tells
+    zope.formlib which fields to display.
+    """
+    form_fields = form.Fields(IStaticStylishPortlet)
+    form_fields['text'].custom_widget = WYSIWYGWidget
+
+    label = _(u"title_edit_staticstylish_portlet", default=u"Edit Static Stylish text portlet")
+    description = _(u"description_staticstylish_portlet", default=u"A portlet which can display static HTML text with different styles.")
Index: /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/tests/__init__.py
===================================================================
--- /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/tests/__init__.py	(revision 2481)
+++ /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/tests/__init__.py	(revision 2481)
@@ -0,0 +1,1 @@
+#
Index: /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/tests/base.py
===================================================================
--- /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/tests/base.py	(revision 2481)
+++ /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/tests/base.py	(revision 2481)
@@ -0,0 +1,42 @@
+from Products.Five import zcml
+from Products.Five import fiveconfigure
+
+from Testing import ZopeTestCase as ztc
+
+from Products.PloneTestCase import PloneTestCase as ptc
+from Products.PloneTestCase.layer import onsetup
+
+@onsetup
+def setup_product():
+    """Set up additional products and ZCML required to test this product.
+
+    The @onsetup decorator causes the execution of this body to be deferred
+    until the setup of the Plone site testing layer.
+    """
+
+    # Load the ZCML configuration for this package and its dependencies
+
+    fiveconfigure.debug_mode = True
+    import quintagroup.portlet.static
+    zcml.load_config('configure.zcml', quintagroup.portlet.static)
+    fiveconfigure.debug_mode = False
+
+    # We need to tell the testing framework that these products
+    # should be available. This can't happen until after we have loaded
+    # the ZCML.
+
+    ztc.installPackage('quintagroup.portlet.static')
+
+# The order here is important: We first call the deferred function and then
+# let PloneTestCase install it during Plone site setup
+
+setup_product()
+ptc.setupPloneSite(products=['quintagroup.portlet.static'])
+
+class TestCase(ptc.PloneTestCase):
+    """Base class used for test cases
+    """
+
+class FunctionalTestCase(ptc.FunctionalTestCase):
+    """Test case class used for functional (doc-)tests
+    """
Index: /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/tests/test_configlet.py
===================================================================
--- /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/tests/test_configlet.py	(revision 2481)
+++ /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/tests/test_configlet.py	(revision 2481)
@@ -0,0 +1,18 @@
+import unittest
+import doctest
+from Testing import ZopeTestCase as ztc
+
+from quintagroup.portlet.static.tests.base import FunctionalTestCase
+
+def test_suite():
+    return unittest.TestSuite([
+
+        ztc.ZopeDocFileSuite(
+            'configlet.txt', package='quintagroup.portlet.static',
+            test_class=FunctionalTestCase,
+            optionflags=doctest.REPORT_ONLY_FIRST_FAILURE | doctest.NORMALIZE_WHITESPACE | doctest.ELLIPSIS),
+
+     ])
+
+if __name__ == '__main__':
+    unittest.main(defaultTest='test_suite')
Index: /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/tests/test_portlet.py
===================================================================
--- /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/tests/test_portlet.py	(revision 2481)
+++ /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/tests/test_portlet.py	(revision 2481)
@@ -0,0 +1,96 @@
+from zope.component import getUtility, getMultiAdapter
+
+from plone.portlets.interfaces import IPortletType
+from plone.portlets.interfaces import IPortletManager
+from plone.portlets.interfaces import IPortletAssignment
+from plone.portlets.interfaces import IPortletDataProvider
+from plone.portlets.interfaces import IPortletRenderer
+
+from plone.app.portlets.storage import PortletAssignmentMapping
+from plone.portlet.static.tests import test_portlet_static as base
+
+from quintagroup.portlet.static import staticstylishportlet
+
+from quintagroup.portlet.static.tests.base import TestCase
+
+
+class TestPortlet(TestCase):
+
+    def afterSetUp(self):
+        self.setRoles(('Manager', ))
+
+    def test_portlet_type_registered(self):
+        portlet = getUtility(IPortletType, name='quintagroup.portlet.static.StaticStylishPortlet')
+        self.assertEquals(portlet.addview, 'quintagroup.portlet.static.StaticStylishPortlet')
+
+    def test_interfaces(self):
+        portlet = staticstylishportlet.Assignment()
+        self.failUnless(IPortletAssignment.providedBy(portlet))
+        self.failUnless(IPortletDataProvider.providedBy(portlet.data))
+
+    def test_invoke_add_view(self):
+        portlet = getUtility(IPortletType, name='quintagroup.portlet.static.StaticStylishPortlet')
+        mapping = self.portal.restrictedTraverse('++contextportlets++plone.leftcolumn')
+        for m in mapping.keys():
+            del mapping[m]
+        addview = mapping.restrictedTraverse('+/' + portlet.addview)
+
+        addview.createAndAdd(data={})
+
+        self.assertEquals(len(mapping), 1)
+        self.failUnless(isinstance(mapping.values()[0], staticstylishportlet.Assignment))
+
+    def test_invoke_edit_view(self):
+        mapping = PortletAssignmentMapping()
+        request = self.folder.REQUEST
+
+        mapping['foo'] = staticstylishportlet.Assignment()
+        editview = getMultiAdapter((mapping['foo'], request), name='edit')
+        self.failUnless(isinstance(editview, staticstylishportlet.EditForm))
+
+    def test_obtain_renderer(self):
+        context = self.folder
+        request = self.folder.REQUEST
+        view = self.folder.restrictedTraverse('@@plone')
+        manager = getUtility(IPortletManager, name='plone.rightcolumn', context=self.portal)
+
+        assignment = staticstylishportlet.Assignment()
+
+        renderer = getMultiAdapter((context, request, view, manager, assignment), IPortletRenderer)
+        self.failUnless(isinstance(renderer, staticstylishportlet.Renderer))
+
+
+class TestBaseRenderer(base.TestRenderer):
+    """ Just to be sure base functionality is not broken """
+
+
+class TestRenderer(TestCase):
+
+    def afterSetUp(self):
+        self.setRoles(('Manager', ))
+
+    def renderer(self, context=None, request=None, view=None, manager=None, assignment=None):
+        context = context or self.folder
+        request = request or self.folder.REQUEST
+        view = view or self.folder.restrictedTraverse('@@plone')
+        manager = manager or getUtility(IPortletManager, name='plone.rightcolumn', context=self.portal)
+
+        assignment = assignment or staticstylishportlet.Assignment()
+        return getMultiAdapter((context, request, view, manager, assignment), IPortletRenderer)
+
+    def test_render(self):
+        r = self.renderer(context=self.portal, assignment=staticstylishportlet.Assignment(styling='paleBackground'))
+        r = r.__of__(self.folder)
+        r.update()
+        output = r.render()
+        
+        self.failUnless('paleBackground' in output, 'Custom styling is not applied')
+
+
+def test_suite():
+    from unittest import TestSuite, makeSuite
+    suite = TestSuite()
+    suite.addTest(makeSuite(TestPortlet))
+    suite.addTest(makeSuite(TestBaseRenderer))
+    suite.addTest(makeSuite(TestRenderer))
+    return suite
Index: /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/utils.py
===================================================================
--- /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/utils.py	(revision 2481)
+++ /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/utils.py	(revision 2481)
@@ -0,0 +1,27 @@
+"""Some utility functions for common use"""
+
+from Products.CMFCore.utils import getToolByName
+
+def getVocabulary(context):
+    pp = getToolByName(context, 'portal_properties', None)
+    styles = None
+    if pp is not None:
+        sheet = getattr(pp, 'staticportlet_properties', None)
+        if sheet is not None:
+            dropdown_list = sheet.getProperty('portlet_dropdown', None)
+            if dropdown_list is not None:
+                styles = []
+                value_list = []
+                for line in dropdown_list:
+                    values = filter(lambda x:x.strip(), line.split('|', 1))
+                    if len(values) == 0:
+                        continue
+                    elif len(values) == 1:
+                        value = title = values[0]
+                    else:
+                        value = values[0]
+                        title = values[1]
+                    if value not in value_list:
+                        value_list.append(value)
+                        styles.append((value, title))
+    return styles
Index: /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/vocabularies.py
===================================================================
--- /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/vocabularies.py	(revision 2481)
+++ /quintagroup.portlet.static/tags/0.2/quintagroup/portlet/static/vocabularies.py	(revision 2481)
@@ -0,0 +1,42 @@
+from zope.app.schema.vocabulary import IVocabularyFactory
+from zope.interface import implements
+from zope.schema.vocabulary import SimpleTerm, SimpleVocabulary
+
+from Products.CMFCore.utils import getToolByName
+
+from quintagroup.portlet.static.utils import getVocabulary
+from quintagroup.portlet.static import StaticStylishPortletMessageFactory as _
+
+
+# fallback in case there is no portlet_dropdown lines property inside
+# staticporlet_properties property sheed in portal_properties tool
+PORTLET_CSS_STYLES = (
+    (u"portletStaticClassOne", u"Class One"),
+)
+
+class PortletCSSVocabulary(object):
+    implements(IVocabularyFactory)
+
+    def __call__(self, context):
+        styles = getVocabulary(context)
+        if styles is None:
+            styles = PORTLET_CSS_STYLES
+        charset = self._charset(context)
+        items = []
+        for value, title in styles:
+            if not isinstance(title, unicode):
+                title = title.decode(charset)
+            if not isinstance(value, unicode):
+                value = value.decode(charset)
+            items.append(SimpleTerm(value, value, _(title)))
+        return SimpleVocabulary(items)
+
+    def _charset(self, context):
+        pp = getToolByName(context, 'portal_properties', None)
+        if pp is not None:
+            site_properties = getattr(pp, 'site_properties', None)
+            if site_properties is not None:
+                return site_properties.getProperty('default_charset', 'utf-8')
+        return 'utf-8'
+
+PortletCSSVocabulary = PortletCSSVocabulary()
Index: /quintagroup.portlet.static/tags/0.2/setup.cfg
===================================================================
--- /quintagroup.portlet.static/tags/0.2/setup.cfg	(revision 2481)
+++ /quintagroup.portlet.static/tags/0.2/setup.cfg	(revision 2481)
@@ -0,0 +1,2 @@
+[egg_info]
+
Index: /quintagroup.portlet.static/tags/0.2/setup.py
===================================================================
--- /quintagroup.portlet.static/tags/0.2/setup.py	(revision 2481)
+++ /quintagroup.portlet.static/tags/0.2/setup.py	(revision 2481)
@@ -0,0 +1,33 @@
+from setuptools import setup, find_packages
+import os
+
+version = '0.2'
+
+setup(name='quintagroup.portlet.static',
+      version=version,
+      description="Static portlet with one extra styling field",
+      long_description=open("README.txt").read() + "\n" +
+                       open(os.path.join("docs", "HISTORY.txt")).read(),
+      # Get more strings from http://www.python.org/pypi?%3Aaction=list_classifiers
+      classifiers=[
+        "Framework :: Plone",
+        "Programming Language :: Python",
+        "Topic :: Software Development :: Libraries :: Python Modules",
+        ],
+      keywords='plone static portlet',
+      author='Vitaliy Podoba',
+      author_email='piv@quintagroup.com',
+      url='http://svn.quintagroup.com/products/quintagroup.portlet.static',
+      license='GPL',
+      packages=find_packages(exclude=['ez_setup']),
+      namespace_packages=['quintagroup', 'quintagroup.portlet'],
+      include_package_data=True,
+      zip_safe=False,
+      install_requires=[
+          'setuptools',
+          # -*- Extra requirements: -*-
+      ],
+      entry_points="""
+      # -*- Entry points: -*-
+      """,
+      )
